#ifndef BLOCKERS_ARRAY_H_INCLUDED
#define BLOCKERS_ARRAY_H_INCLUDED

#include <iostream>
#include <cstdio>
#include <simplecpp>
#include <cstdlib>
#include "theme.h"
using namespace std;
struct point
{
    int x;
    int y;
    point (){return;}
    point (int a,int b){x=a;y=b;}
    bool operator==(point &c)
    {
        if(x==c.x&&y==c.y){return true;}
        else return false;
    }
    point operator=(point &c)
    {
        point z;
        z.x=c.x;
        z.y=c.y;
        return z;
    }
};
struct BLOCK
                {bool horizontal;//1 for horizontal and 0 for vertical
                 int length;//in terms of cells
                 int x;//of lower or left end
                 int y;//of lower or left end
                 int occupied_points_x[3];
                 int occupied_points_y[3];
                 //BLOCK operator=(BLOCK &a)
                //{
                 //   BLOCK z;
                 //   z.block_Id=a.block_Id;
                  //  z.horizontal=a.horizontal;
                  //  z.length=a.length;
                   // z.x=a.x;
                   // z.y=a.y;
                   // for(int i=0;i<3;i++)
                   // {
                   //     z.occupied_points[i]=a.occupied_points[i];
                   // }
                  //  return z;
               // }
                 void moveblock(int dist)
                 {
                     if(horizontal){x=x+dist;}
                     if(!horizontal){y=y+dist;}
                     return;
                 }
                 int block_Id;
                 void define_block_Id()
                 {
                     block_Id=(2^x)+(5^y);
                     if(horizontal)
                     {
                         for(int i=x;i<length+x;i++)
                         {
                             occupied_points_y[i-x]=y;
                             occupied_points_x[i-x]=i;
                         }
                     }
                     if(!(horizontal))
                     {
                         for(int i=y;i<y+length;i++)
                         {
                             occupied_points_y[i-y]=i;
                             occupied_points_x[i-y]=x;
                         }
                     }
                     return;
                 }
                };
struct blockers_prisoner
{
    BLOCK blockers[];
    BLOCK prisoner;
    int num_block;
};

struct config
{
    int Id;//this_is_actually used to find minimum number of moves
    bool isblockthere[6][6];//array to represent positions where block is present
    BLOCK blockers[13];//array of all the blocks except prisoner
    BLOCK prisoner;//block prisoner
    int num_block;//total num_of_blocks
    int config_creating_move;//the move which created this config // here move is the move of the block
    int Id_block_moved;//Id of last moved block
};
bool can_block_be_moved(BLOCK block,bool isblockthere[6][6])
//checks whether there is any space to move the block
{
    bool a,b;
    if(block.horizontal)
    {
        if(block.x!=0)
            {if(isblockthere[block.x-1][block.y]){a=0;}
            if(isblockthere[block.x-1][block.y]==0){a=1;}}
            if(isblockthere[block.x+block.length][block.y]){b=0;}
            if(isblockthere[block.x+block.length][block.y]==0){b=1;}
    }
    if(!(block.horizontal))
    {
        if(block.y!=0)
        {if(isblockthere[block.x][block.y-1]){a=0;}
        if(isblockthere[block.x][block.y-1]==0){a=1;}}
        if(isblockthere[block.x][block.y+block.length]){b=0;}
        if(isblockthere[block.x][block.y+block.length]==0){b=1;}
    }
    return (a||b);
}
int get_x(int click)//function to get X co-ordinate
{
    return (click/65536);
}
int get_y(int click)//function to get Y co-ordinate
{
    return (click%65536);
}
void clean_block(BLOCK block,bool isblockthere[6][6])//this will erase data related to that block
{
    if(block.horizontal)
    {
        for(int i=block.x;i<block.x+block.length;i++)
        {
            isblockthere[i][block.y]=false;
        }
    }
    if(!(block.horizontal))
    {
        for(int i=block.y;i<block.y+block.length;i++)
        {
            isblockthere[block.x][i]=false;
        }
    }
    return;
}
void place_block(BLOCK block,bool isblockthere[6][6])//given details of any block,this function will place that block in the array
{
    int i;//index variable
    if(block.horizontal)//in case block is horizontal
    {
        for(i=block.x;i<block.x+block.length;i++)
        {
            isblockthere[i][block.y]=1;
        }
    }
    if(!(block.horizontal))//in case block is vertical
    {
        for(i=block.y;i<(block.y)+(block.length);i++)
        {
            isblockthere[block.x][i]=1;
        }
    }
    return;
}
bool does_the_block_overlap(BLOCK block,bool isblockthere[6][6])//for checking whether we are placing two blocks one over the other
{
    int i;//index
    bool a=0;
    if(block.horizontal)
    {
        for(i=block.x;i<block.x+block.length;i++)
        {
            if(isblockthere[i][block.y]){a=1;break;}
        }
    }
    else if(!(block.horizontal))
    {
        for(i=block.y;i<block.y+block.length;i++)
        {
            if(isblockthere[block.x][i]){a=1;break;}
        }
    }
    return a;
}
struct config_rec
{
    config config_data;
    Rectangle blockers[13];
    Rectangle prisoner;
    theme curr_theme;
    private:
    bool is_click_on_a_block(int x,int y)
    {
        return (config_data.isblockthere[x][y]);
    }
    int block_Id_clicked(int x, int y)
    {
        if(x==-100&&y==-100){return -2;}//undo button
        if(x==99&&y==99){return -3;}//quit button
        if(x==88&&y==88){return 88;}//restart button
        if(x==77&&y==77){return 77;}//back_button
        int i,j,k;
        if(config_data.prisoner.occupied_points_y[0]==y)
        {
            for(i=0;i<config_data.prisoner.length;i++)
            {
                if(config_data.prisoner.occupied_points_x[i]==x)
                {
                    return (-1);
                }
            }//return -1 if prisoner
        }
        for(i=0;i<config_data.num_block;i++)
        {
            if(config_data.blockers[i].horizontal)
            {
                if(config_data.blockers[i].occupied_points_y[0]==y)
                {
                    for(k=0;k<config_data.blockers[i].length;k++)
                    {
                        if(config_data.blockers[i].occupied_points_x[k]==x)
                        {
                            return i;//returning index to the blocker detected
                        }
                    }
                }
            }
            if(!(config_data.blockers[i].horizontal))
            {
                if(config_data.blockers[i].occupied_points_x[0]==x)
                {
                    for(k=0;k<config_data.blockers[i].length;k++)
                    {
                        if(config_data.blockers[i].occupied_points_y[k]==y)
                        {
                            return i;//returning index to the blocker detected
                        }
                    }
                }
            }
        }
    }
    void display_a_blocker(int i,theme curr_theme)//this function is given information about a particular block named "a"
{
        if(config_data.blockers[i].horizontal)
        {
        int X=30+(40*(config_data.blockers[i].x))+(20*(config_data.blockers[i].length));
        int Y=310-(40*(config_data.blockers[i].y));
        int length=40*(config_data.blockers[i].length);
        blockers[i].reset(X,Y,length,40);
        blockers[i].setFill(1);
        blockers[i].setColor(COLOR(curr_theme.blocker_colour.R,curr_theme.blocker_colour.G,curr_theme.blocker_colour.B));
        blockers[i].imprint();
        }
    if(!(config_data.blockers[i].horizontal))
    {
        int X=50+(40*(config_data.blockers[i].x));
        int Y=330-(40*(config_data.blockers[i].y))-(20*(config_data.blockers[i].length));
        int length=40*(config_data.blockers[i].length);
        blockers[i].reset(X,Y,40,length);
        blockers[i].setColor(COLOR(curr_theme.blocker_colour.R,curr_theme.blocker_colour.G,curr_theme.blocker_colour.B));
        blockers[i].setFill(1);
        blockers[i].imprint();
    }
}
void display_a_prisoner(theme curr_theme)
{
        int X=30+(40*(config_data.prisoner.x))+(20*(config_data.prisoner.length));
        int Y=310-(40*(config_data.prisoner.y));
        int length=40*(config_data.prisoner.length);
        prisoner.reset(X,Y,length,40);
        Rectangle temp(X,Y,length,40);
        temp.setColor(GREEN);
        prisoner.setColor(COLOR(curr_theme.prisoner_colour.R,curr_theme.prisoner_colour.G,curr_theme.prisoner_colour.B));
        prisoner.setFill(1);
        prisoner.imprint();
        return;
}
void hide_garbage_blockers()
{
    for(int i=config_data.num_block;i<13;i++)
    {
        blockers[i].hide();
    }
    return;
}
void draw_temp_rec(int x,int y)
{
    int X=50+40*x;
    int Y=310-40*y;
    Rectangle temp(X,Y,40,40);
    temp.setColor(COLOR(curr_theme.backgrd_colour.R,curr_theme.backgrd_colour.G,curr_theme.backgrd_colour.B));
    temp.setFill(1);
    temp.imprint();
}
void undo()
{
    FILE *fp;
    fp=fopen("undo_data","rb");
    rewind(fp);
    config a;
    fread(&a,sizeof(config_data),1,fp);
    config_data=a;
    return;
}
int detect_block_clicked()
{
    int x,y;//click co-ordinates
    int cell_x=(-100),cell_y=(-100); //co-ordinates of cell clicked (6*6 cell)
    XEvent click;
    bool a=0,b=0;
    bool quit=0,restart_butt=0,back_butt=0;
    do
    {
        do
            {
            nextEvent(click);
            }
        while(!(mouseButtonPressEvent(click)));
        x=click.xbutton.x;
        y=click.xbutton.y;
        if((x>30&&x<270)&&(y>90&&y<330))
            {
                cell_x=(x-30)/(40);
                cell_y=(5-((y-90)/(40)));
                a=(is_click_on_a_block(cell_x,cell_y));
            }
        if((x>120&&x<180)&&(y<400&&y>360)){undo();break;}
        if((x>20&&x<80)&&(y<400&&y>360))
        {
            back_butt=1;
            cell_x=77;
            cell_y=77;
        }
        if((x>120)&&(x<180)&&(y>440&&y<480))
        {
            quit=1;
            cell_y=99;
            cell_x=99;
        }
        if((x<280&&x>220)&&(y<400&&y>360))
        {
            restart_butt=1;
            cell_x=88;
            cell_y=88;
        }
    }
    while((!a)&&(!quit)&&(!restart_butt)&&(!back_butt));
    return (block_Id_clicked(cell_x,cell_y));//returns index of block in array or -1 if prisoner is clicked
}
void move_block(int block_index,char i)
{
    if(block_index==(-1))
    {
            if(can_block_be_moved(config_data.prisoner,config_data.isblockthere))
            {
            if(i=='a')
            {
            clean_block(config_data.prisoner,config_data.isblockthere);
            config_data.prisoner.moveblock(-1);
            if((!(does_the_block_overlap(config_data.prisoner,config_data.isblockthere)))&&(config_data.prisoner.x>(-1)))
                {place_block(config_data.prisoner,config_data.isblockthere);
                config_data.prisoner.define_block_Id();
                draw_temp_rec(config_data.prisoner.x+config_data.prisoner.length,config_data.prisoner.y);}
            else    {config_data.prisoner.moveblock(1);place_block(config_data.prisoner,config_data.isblockthere);}
            }
        if(i=='d')
            {
            clean_block(config_data.prisoner,config_data.isblockthere);
            config_data.prisoner.moveblock(1);
            if((!(does_the_block_overlap(config_data.prisoner,config_data.isblockthere)))&&(config_data.prisoner.x<5))
                {place_block(config_data.prisoner,config_data.isblockthere);
                config_data.prisoner.define_block_Id();
                draw_temp_rec(config_data.prisoner.x-1,config_data.prisoner.y);}
            else    {config_data.prisoner.moveblock(-1);place_block(config_data.prisoner,config_data.isblockthere);}
            }
            }
    }
    else if(can_block_be_moved(config_data.blockers[block_index],config_data.isblockthere))
    {
        if(config_data.blockers[block_index].horizontal)
    {
        if(i=='a')
            {
            clean_block(config_data.blockers[block_index],config_data.isblockthere);
            config_data.blockers[block_index].moveblock(-1);
            if((!(does_the_block_overlap(config_data.blockers[block_index],config_data.isblockthere)))&&(config_data.blockers[block_index].x>(-1)))
                {place_block(config_data.blockers[block_index],config_data.isblockthere);
                config_data.blockers[block_index].define_block_Id();
                draw_temp_rec(config_data.blockers[block_index].x+config_data.blockers[block_index].length,config_data.blockers[block_index].y);}
            else    {config_data.blockers[block_index].moveblock(1);place_block(config_data.blockers[block_index],config_data.isblockthere);}
            }
        if(i=='d')
            {
            clean_block(config_data.blockers[block_index],config_data.isblockthere);
            config_data.blockers[block_index].moveblock(1);
            if((!(does_the_block_overlap(config_data.blockers[block_index],config_data.isblockthere)))&&((config_data.blockers[block_index].x<=(6-config_data.blockers[block_index].length))))
                {place_block(config_data.blockers[block_index],config_data.isblockthere);
                config_data.blockers[block_index].define_block_Id();
                draw_temp_rec(config_data.blockers[block_index].x-1,config_data.blockers[block_index].y);}
            else    {config_data.blockers[block_index].moveblock(-1);place_block(config_data.blockers[block_index],config_data.isblockthere);}
            }
    }
    else if(!(config_data.blockers[block_index].horizontal))
    {
        if(i=='w')
            {
                clean_block(config_data.blockers[block_index],config_data.isblockthere);
                config_data.blockers[block_index].moveblock(1);
                if((!(does_the_block_overlap(config_data.blockers[block_index],config_data.isblockthere)))&&((config_data.blockers[block_index].y<=((6-config_data.blockers[block_index].length)))))
                    {place_block(config_data.blockers[block_index],config_data.isblockthere);
                    config_data.blockers[block_index].define_block_Id();
                    draw_temp_rec(config_data.blockers[block_index].x,config_data.blockers[block_index].y-1);}
                else    {config_data.blockers[block_index].moveblock(-1);place_block(config_data.blockers[block_index],config_data.isblockthere);}
            }
        if(i=='s')
            {
                clean_block(config_data.blockers[block_index],config_data.isblockthere);
                config_data.blockers[block_index].moveblock(-1);
                if((!(does_the_block_overlap(config_data.blockers[block_index],config_data.isblockthere)))&&((config_data.blockers[block_index].y>(-1))))
                    {place_block(config_data.blockers[block_index],config_data.isblockthere);
                    config_data.blockers[block_index].define_block_Id();
                    draw_temp_rec(config_data.blockers[block_index].x,config_data.blockers[block_index].y+config_data.blockers[block_index].length);}
                else    {config_data.blockers[block_index].moveblock(1);place_block(config_data.blockers[block_index],config_data.isblockthere);}
            }
    }
    }
}
void highlight_block(int i,theme curr_theme)//changes colour of the block
{
    if(i==(-2)){return;}
    if(i==(-3)){return;}
    if(i==(-1))
        {
            prisoner.setColor(COLOR(curr_theme.highlight_prisoner.R,curr_theme.highlight_prisoner.G,curr_theme.highlight_prisoner.B));
            prisoner.setFill(1);
            prisoner.imprint();
        }
    else{
    blockers[i].setColor(COLOR(curr_theme.highlight_blockers.R,curr_theme.highlight_blockers.G,curr_theme.highlight_blockers.B));
    blockers[i].setFill(1);
    blockers[i].imprint();
    }
}

public:

    void set_blocker_prisoner()
    {
        for(int i=0;i<(config_data.num_block);i++)
        {
            display_a_blocker(i,curr_theme);
        }
        hide_garbage_blockers();
        display_a_prisoner(curr_theme);
    }
    int play_game()
    {
        XEvent key;
        int block_clicked;
        char key_char;
        Text num_moves;
        int number_of_moves=0;
        FILE*fp;
        fp=fopen("undo_data","wb");
        rewind(fp);
        int quit_button=0;
        config original;
        original=config_data;
    do
        {
            num_moves.reset(50,50,number_of_moves);
            block_clicked=detect_block_clicked();
            if(block_clicked==-2)
            {
                number_of_moves--;
                set_blocker_prisoner();
            }
            if(block_clicked==-3)
        {
            return -8;//game quitted;
        }
            if(block_clicked==88)
            {
                config_data=original;break;
            }
            if(block_clicked==77)
            {
                return 77;
            }
            if((block_clicked==(-1))||(config_data.blockers[block_clicked].horizontal))
            {
            do
            {
                highlight_block(block_clicked,curr_theme);
                set_blocker_prisoner();
                do
                    {
                    nextEvent(key);
                    }
                while(!(keyPressEvent(key)));
                    key_char=charFromEvent(key);
            }while((key_char!='a')&&(key_char!='d'));
            if(block_clicked==(-1))
            {
                move_block(block_clicked,key_char);
                display_a_prisoner(curr_theme);
                number_of_moves++;
            }
            else
                {   highlight_block(block_clicked,curr_theme);
                    move_block(block_clicked,key_char);
                    display_a_blocker(block_clicked,curr_theme);
                    number_of_moves++;
                }
            }
            else if(block_clicked!=(-2))//-2 indicates undo clicked
            {if(!(config_data.blockers[block_clicked].horizontal))
                {do
            {
                do
                    {
                    nextEvent(key);
                    }
                while(!(keyPressEvent(key)));
                    key_char=charFromEvent(key);
            }while((key_char!='w')&&(key_char!='s'));
                    highlight_block(block_clicked,curr_theme);
                    move_block(block_clicked,key_char);
                    display_a_blocker(block_clicked,curr_theme);
                    number_of_moves++;
                }
            }
            config a;
            a=config_data;
            rewind(fp);
            fwrite(&a,sizeof(config),1,fp);
            if(config_data.prisoner.x==4){return -7;}//-7 for won
        }while(1);

        return block_clicked;
    }

};



int display_arrangement(int level_no,theme a)
{
    char level_names[37][3];
    FILE *fp;
    fp=fopen("level_data","rb");
    if(fp==NULL){cout<<"failed to link level_names"<<endl;return -1000;}
    rewind(fp);
    fread(level_names,sizeof(level_names),1,fp);
    fclose(fp);

    config_rec temp;
    FILE* config_file;
    //getting size of config structure
    config_file=fopen("config_size","rb");
    if(config_file==NULL){cout<<"error in allocating config_size file"<<endl;return -1000;}
    int config_size;
    rewind(config_file);
    fread(&config_size,4,1,config_file);
    fclose(config_file);
    //getting the config already saved
    config_file=fopen(level_names[level_no-1],"rb");
    if(config_file==NULL){cout<<"error in allocating file"<<endl;return -100;};
    config original;
    rewind(config_file);
    fread(&temp.config_data,config_size,1,config_file);
    fclose(config_file);
    //end
    Text level_no_display;
    a.set_highlight();
    temp.curr_theme=a;
    int display_report;
    for(int i=5;i>=0;i--){for(int j=0;j<6;j++){cout<<temp.config_data.isblockthere[j][i];}cout<<endl;}
    do
    {
    temp.set_blocker_prisoner();
    level_no_display.reset(150,50,level_no);
    display_report=temp.play_game();
    if(display_report==-7)
    {
        if(level_no=36){level_no=0;}
            Rectangle back_ground(150,210,240,240);
            back_ground.setColor(COLOR(temp.curr_theme.backgrd_colour.R,temp.curr_theme.backgrd_colour.G,temp.curr_theme.backgrd_colour.B));
            back_ground.setFill(1);
            back_ground.imprint();
            level_no++;
            config_file=fopen(level_names[level_no],"rb");
        if(config_file==NULL){cout<<"error in allocating file"<<endl;return -100;};
        config original;
        rewind(config_file);
        fread(&temp.config_data,config_size,1,config_file);
        fclose(config_file);
    }
    }while (display_report!=-8);
    return display_report;

}


#endif // BLOCKERS_ARRAY_H_INCLUDED
