#ifndef NUM_MOVES_CALCULATOR_H_INCLUDED
#define NUM_MOVES_CALCULATOR_H_INCLUDED
#include <iostream>
#include "random_lvl_function.h"
#include <cstdlib>
#include <ctime>
#include <list>
#include <set>
using namespace std;
bool can_prisoner_escape(BLOCK prisoner,bool isblockthere[6][6])
{
    int i,j;//index variables
    for(i=prisoner.x+prisoner.length;i<6;i++)
    {
        if(isblockthere[i][prisoner.y]){return 0;}
    }
    return 1;
}
bool can_block_be_moved(BLOCK block,bool isblockthere[6][6])
//checks whether there is any space to move the block
{
    bool a,b;
    if(block.horizontal)
    {
        if(block.x!=0)
            {if(isblockthere[block.x-1][block.y]){a=0;}
            if(isblockthere[block.x-1][block.y]==0){a=1;}}
            if(isblockthere[block.x+block.length][block.y]){b=0;}
            if(isblockthere[block.x+block.length][block.y]==0){b=1;}
    }
    if(!(block.horizontal))
    {
        if(block.y!=0)
        {if(isblockthere[block.x][block.y-1]){a=0;}
        if(isblockthere[block.x][block.y-1]==0){a=1;}}
        if(isblockthere[block.x][block.y+block.length]){b=0;}
        if(isblockthere[block.x][block.y+block.length]==0){b=1;}
    }
    return (a||b);
}
void distances_that_block_can_move(BLOCK block,bool isblockthere[6][6],int distances[4])
{
    int i,j,k,l;//indices
    if(block.horizontal)
    {
        for(i=block.x-1,j=0;i>(-1);i--,j++)
        {
            if(isblockthere[i][block.y]){break;}
            if(!(isblockthere[i][block.y])){continue;}
        }
        for(i=j;i>0;i--)
        {
            distances[j-i]=(-i);
        }
        for(i=block.x+block.length,k=0;i<6;i++,k++)
        {
            if(isblockthere[i][block.y]){break;}
            if(!(isblockthere[i][block.y])){continue;}
        }
        for(i=j,l=0;l<k;i++,l++)
        {
            distances[i]=k-l;
        }
        for(i=j+k;i<4;i++)
        {
            distances[i]=0;
        }
    }
    if(!(block.horizontal))
    {
        for(i=block.y-1,j=0;i>(-1);i--,j++)
        {
            if(isblockthere[block.x][i]){break;}
            if(!(isblockthere[block.x][i])){continue;}
        }
        for(i=j;i>0;i--)
        {
            distances[j-i]=(-i);
        }
        for(i=block.y+block.length,k=0;i<6;i++,k++)
        {
            if(isblockthere[block.x][i]){break;}
            if(!(isblockthere[block.x][i])){continue;}
        }
        for(i=j,l=0;l<k;i++,l++)
        {
            distances[i]=k-l;
        }
        for(i=j+k;i<4;i++)
        {
            distances[i]=0;
        }
    }
    return;
}
void array_copy(BLOCK blockers1[13],BLOCK blockers2[13],int num_blocks)
{
    for(int i=0;i<num_blocks;i++)
    {
        blockers1[i].horizontal=blockers2[i].horizontal;
        blockers1[i].length=blockers2[i].length;
        blockers1[i].x=blockers2[i].x;
        blockers1[i].y=blockers2[i].y;
    }
    return;
}
void isblockthere_copy(bool a[6][6],bool b[6][6])
{
    for(int i=0;i<6;i++)
    {
        for(int j=0;j<6;j++)
        {
            a[i][j]=b[i][j];
        }
    }
    return;
}
void config_copy(config a,config b)
{
    array_copy(a.blockers,b.blockers,b.num_block);
    a.Id=b.Id;
    isblockthere_copy(a.isblockthere,b.isblockthere);
    a.num_block=b.num_block;
    a.prisoner=b.prisoner;
    return;
}
bool are_two_blockers_same(BLOCK prisoner1,BLOCK prisoner2,BLOCK a[],BLOCK b[],int num_block)
{
    bool c,d,e,f,g;
    for(int i=0;i<num_block;i++)
    {
        c=(a[i].horizontal!=b[i].horizontal);
        d=(a[i].length!=b[i].length);
        e=(a[i].x!=b[i].x);
        f=(a[i].y!=b[i].y);
        g=c||d||e||f;
    }
    c=(prisoner1.x!=prisoner2.x);
    if(g||c){return 0;}
    return 1;
}
int calculate_num_moves()
{
    long int i,j,k;
    //reading the size of blockers array which is an integer from a file created by random_lvl
    FILE*rec_size_file;
    FILE*blockers_file;
    FILE*prisoner_file;
    rec_size_file=fopen("record_size","rb");
    if(rec_size_file==NULL){cout<<"failed to read rec_size"<<endl;return -1;}
    int rec_size;
    rewind(rec_size_file);
    fread(&rec_size,4,1,rec_size_file);
    fclose(rec_size_file);
    //rec_size reading complete
    //reading num_block_file
    FILE*num_block_file;
    num_block_file=fopen("num_block","rb");
    if(num_block_file==NULL){cout<<"failed to create num_block_file"<<endl;return -1;}
    int num_block;
    rewind(num_block_file);
    fread(&num_block,4,1,num_block_file);
    fclose(num_block_file);
    //reading the blockers array
    blockers_file=fopen("blockers","rb");
    if(blockers_file==NULL){cout<<"failed to create blocker file"<<endl;return -1;}
    BLOCK blockers[13];
    rewind(blockers_file);
    fread(blockers,rec_size,1,blockers_file);
    fclose(blockers_file);
    //reading prisoner info
    int prisoner_size;
    FILE*prisoner_size_file1;
    FILE*prisoner_file1;
    BLOCK prisoner;
    prisoner_size_file1=fopen("prisoner_size","rb");
    if(prisoner_size_file1==NULL){cout<<"failed to create prisoner size file";return -1;}
    rewind(prisoner_size_file1);
    fread(&prisoner_size,4,1,prisoner_size_file1);
    fclose(prisoner_size_file1);
    prisoner_file1=fopen("prisoner","rb");
    if(prisoner_file1==NULL){cout<<"failed to create prisoner file";return -1;}
    rewind(prisoner_file1);
    fread(&prisoner,prisoner_size,1,prisoner_file1);
    fclose(prisoner_file1);
    //isblockthere
    bool isblockthere[6][6];
    FILE*block_present1;
    block_present1=fopen("block_present","rb");
    if(block_present1==NULL){cout<<"failed to create block present 1file"<<endl;return -1;}
    rewind(block_present1);
    fread(&isblockthere,36,1,block_present1);
    fclose(block_present1);
    //over

    list<config>arrangement;//list of all configuarations
    //set <config>checked; // list of already checked config
    //blockers_prisoner a;
   // checked.insert(a);
    int tempa[4];
    config a;
    //blockers[0].horizontal=1;
    //blockers[0].length=2;
    //blockers[0].x=0;
    //blockers[0].y=2;
    //blockers[1].horizontal=1;
    //blockers[1].length=2;
    //blockers[1].x=2;
    //blockers[1].y=1;
    //blockers[2].horizontal=1;
    //blockers[2].length=2;
    //blockers[2].x=2;
    //blockers[2].y=0;
    //blockers[3].horizontal=0;
    //blockers[3].length=2;
    //blockers[3].x=1;
    //blockers[3].y=0;
    //blockers[4].horizontal=0;
    //blockers[4].length=2;
    //blockers[4].x=5;
    //blockers[4].y=3;
    //blockers[5].horizontal=0;
    //blockers[5].length=3;
    //blockers[5].x=3;
    //blockers[5].y=2;
    //blockers[6].horizontal=0;
    //blockers[6].length=3;
    //blockers[6].x=4;
    //blockers[6].y=2;
    //for(i=0;i<6;i++){for(j=0;j<6;j++){isblockthere[j][i]=0;}}
   // for(i=0;i<7;i++)
    //{
   //     place_block(blockers[i],isblockthere);
   // }
   // prisoner={true,2,0,3};
   // place_block(prisoner,isblockthere);
    for(i=0;i<6;i++){for(j=0;j<6;j++){cout<<isblockthere[j][i];}cout<<endl;}cout<<"-------------"<<endl;

    int I=0;
    //copying first elements of array arrangement

    array_copy(a.blockers,blockers,num_block);
    a.prisoner=prisoner;
    a.Id=I;
    isblockthere_copy(a.isblockthere,isblockthere);
    a.num_block=num_block;
    a.config_creating_move=0;
    a.Id_block_moved=0;
    //writing this config to a file
    FILE* config_file;
    config_file=fopen("config_file_temp","wb");
    if(config_file==NULL){cout<<"failed to create config file"<<endl; return -1;}
    int config_size=sizeof(config);
    rewind(config_file);
    fwrite(&a,config_size,1,config_file);
    fclose(config_file);
    FILE * size_of_config;
    size_of_config=fopen("config_size","wb");
    if(size_of_config==NULL){cout<<"failed to create config size file"<<endl; return -1;}
    rewind(size_of_config);
    fwrite(&config_size,4,1,size_of_config);
    fclose(size_of_config);
    config b;
    b=a;
    arrangement.push_back(b);
    for(i=5;i>=0;i--){for(j=0;j<6;j++){cout<<arrangement.front().isblockthere[j][i];}cout<<endl;}cout<<"-----------------"<<endl;
    I=1;
    for(i=0;arrangement.front().Id<20;i++)
    {   cout<<I<<endl;
       //for(int omni=5;omni>=0;omni--){for(int zim=0;zim<6;zim++){cout<<arrangement.front().isblockthere[zim][omni];}cout<<endl;}
       cout<<"----------------------"<<endl;

        if(can_prisoner_escape(arrangement.front().prisoner,arrangement.front().isblockthere))
        {
            return arrangement.front().Id;
        }
        if(can_block_be_moved(arrangement.front().prisoner,arrangement.front().isblockthere))
        {
            distances_that_block_can_move(arrangement.front().prisoner,arrangement.front().isblockthere,tempa);
            for(k=0;k<4;k++)
            {
                if(tempa[k]!=0)
                {
                    a=arrangement.front();
                    if((a.Id_block_moved=0)||((a.Id_block_moved)!=(a.prisoner.block_Id)))//checking if this was not the block which on moving gave this arrangement
                    {
                        clean_block(a.prisoner,a.isblockthere);//deleting previous info from bool array , same as lifting the block
                        a.prisoner.moveblock(tempa[k]);//moving the block according to distances provided in the tempa array
                        place_block(a.prisoner,a.isblockthere);//updating in the bool array
                        a.Id=I;//updating number of moves done till now
                        a.Id_block_moved=a.prisoner.block_Id;//adding which block has been moved to come at this arrangement
                        a.config_creating_move=tempa[k];//adding which move is responsible for creating this arrangement
                        arrangement.push_back(a);
                        a=arrangement.front();
                    }
                    if(a.Id_block_moved==a.prisoner.block_Id)
                    {
                        if((tempa[k])!=(-(a.config_creating_move)))//checking if we are reaching the originally crossed arrangement of blockers by moving prisoner exactly opposite to what we did in last move
                        {
                            //doing the same thing as above
                            clean_block(a.prisoner,a.isblockthere);
                            a.prisoner.moveblock(tempa[k]);
                            place_block(a.prisoner,a.isblockthere);
                            a.Id=I;
                            a.Id_block_moved=a.prisoner.block_Id;
                            a.config_creating_move=tempa[k];
                            arrangement.push_back(a);
                        }
                    }
                }
            }
        }
        for(j=0;j<num_block;j++)
        {
            if(can_block_be_moved(arrangement.front().blockers[j],arrangement.front().isblockthere))
            {
                distances_that_block_can_move(arrangement.front().blockers[j],arrangement.front().isblockthere,tempa);//aquiring distances that the block can move and storing them in tempa array
                for(k=0;k<4;k++)
                {
                    if(tempa[k]!=0)
                    {
                        a=arrangement.front();
                        if((a.Id_block_moved=0)||((a.Id_block_moved)!=a.blockers[j].block_Id))
                        {
                            clean_block(a.blockers[j],a.isblockthere);
                            a.blockers[j].moveblock(tempa[k]);
                            place_block(a.blockers[j],a.isblockthere);
                            (a.Id=I);
                            (a.config_creating_move)=(tempa[k]);
                            (a.Id_block_moved)=(a.blockers[j].block_Id);
                            arrangement.push_back(a);
                            a=arrangement.front();
                        }
                        if(a.Id_block_moved==a.blockers[j].block_Id)
                        {
                            if((a.config_creating_move)!=(-(tempa[k])))
                            {
                                clean_block(a.blockers[j],a.isblockthere);
                                a.blockers[j].moveblock(tempa[k]);
                                place_block(a.blockers[j],a.isblockthere);
                                (a.Id)=(I);
                                (a.config_creating_move)=(tempa[k]);
                                (a.Id_block_moved)=(a.blockers[j].block_Id);
                                arrangement.push_back(a);
                            }
                        }
                    }
                }
            }
        }
        I=(arrangement.front().Id)+1;//advancing num_moves
        arrangement.pop_front();//deleting this arrangement
    }
    return -1;
}
#endif // NUM_MOVES_CALCULATOR_H_INCLUDED
